/*
 * Copyright 2016 - 2023 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#include <ox/model/model.hpp>

#include "scenestatic.hpp"
#include "typeconv.hpp"

#include "scenemodule.hpp"

namespace nostalgia::scene {

class SceneModule: public foundation::Module {
	private:
		SceneDocToSceneStaticConverter sceneDocToSceneStaticConverter;

	public:
		[[nodiscard]]
		ox::Vector<foundation::TypeDescGenerator> types() const noexcept override {
			return {
				foundation::generateTypeDesc<SceneDoc>,
				foundation::generateTypeDesc<SceneStatic>,
			};
		}

		[[nodiscard]]
		ox::Vector<const foundation::BaseConverter*> converters() const noexcept override {
			return {
				&sceneDocToSceneStaticConverter,
			};
		}

		[[nodiscard]]
		ox::Vector<foundation::PackTransform> packTransforms() const noexcept override {
			return {
				foundation::transformRule<SceneDoc, SceneStatic>,
			};
		}

};

static SceneModule mod;
const foundation::Module *module() noexcept {
	return &mod;
}

}
